<template>
      <el-dialog
    v-model="props.isDialogVisible"
    top="5vh"
    custom-class="custom-dialog"
    :show-close="false"
    :before-close="onClose"
    destroy-on-close
  >
    <div class="relative custom-header">
      {{ props.promotion.Title ?? "" }}
      <div
        :class="[
          'absolute right-7 top-4'
        ]"
      >
        <font-awesome-icon
          class="text-[25px] cursor-pointer close-icon"
          icon="xmark"
          @click="onClose"
        />
      </div>
    </div>
    <div class="custom-content px-[40px] pt-[40px]">
      <div class="flex dialog-border-bottom pb-[20px] gap-[20px]">
        <div
          class="w-[var(--promotion-dialog-image-width)] h-[var(--promotion-dialog-image-height)] rounded-lg overflow-hidden"
        >
          <img
            v-lazy="props.promotion.ImagePathForDisplay"
            class="object-contain w-full h-full"
            @error="handleError"
          />
        </div>
        <div class="flex flex-col w-[320px]">
          <div class="promotion-dialog-date-range">
            {{ props.promotion.DateRangeForDisplay }}
          </div>
          <div class="promotion-dialog-title">
            {{ props.promotion.Title ?? ""}} ({{ props.promotion.PromoCode }})
          </div>
          <div class="promotion-dialog-remark" v-html="props.promotion.Remark"></div>
          <div v-if="selectedTheme === 'black'" class="py-[20px] text-center">
            <nuxt-link v-if="!authenticated" to="/login">
              <el-button type="secondary" class="apply promotion-button" round
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[props.promotion.PromotionTypeId]}_${props.promotion.Id}`"
              >
                {{ $t("apply") }}
              </el-button>
            </nuxt-link>
            <el-button
              v-if="props.buttonApplyPromotionEnabled(props.promotion)"
              type="secondary"
              class="apply promotion-button"
              round
              @click="onApplyPromotion(props.promotion)"
              :loading="props.isProcessing && props.isApplying"
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[props.promotion.PromotionTypeId]}_${props.promotion.Id}`"
            >
              {{ $t("apply") }}
            </el-button>
          </div>
        </div>
      </div>
    </div>
    <div
      :class="[
        'pt-[20px] px-[40px]',
        { 'pb-[40px]': selectedTheme === 'black' },
      ]"
    >
      <el-scrollbar max-height="300px">
        <div class="promotion-content fc-text4" v-html="props.promotion.Content"></div>
      </el-scrollbar>
    </div>
    <div
      v-if="selectedTheme !== 'black'"
      class="flex pt-[40px] pb-[28px] justify-center gap-[16px]"
    >
      <el-button
        plain
        round
        type="primary"
        class="close promotion-button no-field-btn"
        @click="onClose"
      >
        {{ $t("close") }}
      </el-button>
      <nuxt-link v-if="!props.authenticated" to="/login">
        <el-button type="primary" class="apply promotion-button" round
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[props.promotion.PromotionTypeId]}_${props.promotion.Id}`"
        >
          {{ $t("apply") }}
        </el-button>
      </nuxt-link>
      <el-button
        v-if="props.buttonApplyPromotionEnabled(props.promotion)"
        type="primary"
        class="apply promotion-button"
        round
        @click="onApplyPromotion(props.promotion)"
        :loading="props.isProcessing && props.isApplying"
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[props.promotion.PromotionTypeId]}_${props.promotion.Id}`"
      >
        {{ $t("apply") }}
      </el-button>
    </div>
  </el-dialog>
</template>
<script lang="ts" setup>
import { IPromotion } from "@/models/promotion/promotion";
import { store } from "@/store";
import { computed, defineComponent, PropType, ref, defineProps, defineEmits } from "vue";
import {ID} from "~~/utils/constants";
const props = defineProps({
    promotion: {
        type: Object as PropType<IPromotion>,
        default: false,
    },
    isDialogVisible: {
        type: Boolean,
        default: false,
    },
    authenticated: {
        type: Boolean,
        required: true,
    },
    isApplying: {
      type: Boolean,
      required: false,
    },
    isProcessing: {
      type: Boolean,
      default: false,
    },
    buttonApplyPromotionEnabled: {
      type: Function,
      required: true,
    },
});
const selectedTheme = computed(() => store.state.selectedThemeName);
const emit= defineEmits(["closeModal"]);
const onClose = () => {
    emit("closeModal", false);
};
</script>
<style lang="scss">
:root {
  --promotion-card-height: 380px;
  --promotion-card-width: 392px;
  --promotion-image-border-color: var(--hint);
  --promotion-card-background: var(--background5);
  --promotion-more-info-button-color: var(--primary);
  --promotion-more-info-active-button-color: var(--text);
  --promotion-apply-button-color: var(--primary);
  --promotion-apply-button-text-color: var(--textBtn);
  --promotion-close-button-color: var(--failure);
  --promotion-font-color: var(--text);
  --promotion-button-width: 172px;
  --promotion-date-range-color: var(--primary);
  --promotion-title-color: var(--text5);
  --promotion-remark-color: var(--text5);
  --promotion-dialog-background: var(--background5);
  --promotion-dialog-header-background: var(--background1);
  --promotion-dialog-image-width: 392px;
  --promotion-dialog-image-height: 168px;
  --promotion-dialog-width: 812px;
  --promotion-dialog-content-color: var(--text2);
  --promotion-dialog-close-icon: var(--border);
  --promotion-dialog-border-button: var(--primary);
}
.custom-header {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 12px 0px;
  font-size: 20px;
  font-weight: 700;
  color: var(--textBtn);
  background: var(--primary);
}
.el-dialog {
    --el-dialog-width: var(--promotion-dialog-width);
    border-radius: 15px;
    overflow: hidden;
}
.custom-dialog {
    .el-dialog__header {
        padding: 0;
    }
    .el-dialog__body {
        padding: 0;
        background: var(--promotion-dialog-background);

        .dialog-border-bottom {
        border-bottom: 1px solid var(--promotion-dialog-border-button);
        }
    }
    .el-scrollbar {
        max-height: 300px;
        height: auto;

        .el-scrollbar__wrap {
        height: auto;
        }
    }
    .custom-header {
        display: flex;
        justify-content: center;
        align-items: center;
        padding: 12px 0px;
        font-size: 20px;
        font-weight: 700;
        color: var(--textBtn);
        background: var(--primary);
    }
}
</style>